unit FancyExport;
interface
uses SysUtils, Windows, Graphics, Dialogs, PPControl;

procedure XP_BMP(const FileName:string);
procedure XP_JASC_PAL(const FileName:string);

implementation

procedure XP_BMP(const FileName:string);
var BMP:TBitmap;
    PAL:PLogPalette;
    C,Y:integer; L:PByteArray;
begin try
  if not Assigned(ReducedBMP) then exit;
  // Bitmap anlegen
  BMP:=TBitmap.Create;
  with BMP do begin
    Width:=SizeX; Height:=SizeY;
    PixelFormat:=pf8bit;
  end;
  // Palette basteln
  GetMem(PAL,sizeof(TLogPalette)+sizeof(TPaletteEntry)*255);
  PAL^.palVersion:=$300;
  PAL^.palNumEntries:=256;
  for C:=0 to 255 do with PPColors[C].Color,PAL^.palPalEntry[C] do begin
    peRed:=R; peGreen:=G; peBlue:=B; 
  end;
  BMP.Palette:=CreatePalette(PAL^);
  // Zeilen kopieren
  for Y:=0 to (SizeY-1) do begin
    L:=BMP.ScanLine[Y];
    Move(PPData[Y*SizeX],L[0],SizeX);
  end;
  // Alles fertigmachen
  BMP.SaveToFile(FileName);
  DeleteObject(BMP.Palette);
  FreeMem(PAL);
  BMP.Free;
except
  MessageDlg('Fehler beim Bitmap-Export!',mtError,[mbOK],0);
end; end;

procedure XP_JASC_PAL(const FileName:string);
var t:system.text;
    C:integer; cc:char;
    PAL:array[char]of TRGB;
begin
  // Palette kreieren
  for C:=0 to 255 do with PAL[char(C)] do begin
    R:=C; B:=C; G:=C;
  end;
  for C:=255 downto 0 do with PPColors[C] do if EntryType=etSelected then
    PAL[Character]:=Color;
  // Palette speichern
  AssignFile(t,FileName);
  {$I-} Rewrite(t); {$I+}
  if IOresult<>0 then begin
    MessageDlg('Kann Datei'^M#34+FileName+#34^M'nicht schreiben!',mtError,[mbOK],0);
    exit;
  end;
  writeln(t,'JASC-PAL');
  writeln(t,'0100');
  writeln(t,'256');
  for cc:=#0 to #255 do with PAL[cc] do
    writeln(t,R,#32,G,#32,B);
  CloseFile(t);
end;

end.
