unit Intro;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

const INTROSIZEX=240;
      INTROSIZEY=288;

type
  TIntroForm = class(TForm)
    AnimationTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure AnimationTimerTimer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    Image,Mask,Back,BMP:TBitmap;
    Rendered:boolean;
    Phase:integer;
    procedure FormEraseBackground(var msg:TMessage); message WM_ERASEBKGND;
    procedure RenderTrans(Alpha:integer);
  public
    { Public declarations }
  end;

var
  IntroForm: TIntroForm;

implementation

uses Preview;

{$R *.dfm}
{$R pplogo.res}

procedure TIntroForm.FormCreate(Sender: TObject);
begin
  Width:=INTROSIZEX; Height:=INTROSIZEY;
  Left:=(Screen.Width-INTROSIZEX) SHR 1;
  Top:=(Screen.Height-INTROSIZEY) SHR 1;
  Rendered:=false;
end;

procedure TIntroForm.FormShow(Sender: TObject);
begin
  Rendered:=false;
  Image:=TBitmap.Create;
  Image.LoadFromResourceName(HInstance,'PPLOGO_IMAGE');
  Image.PixelFormat:=pf24bit;
  Mask:=TBitmap.Create;
  Mask.LoadFromResourceName(HInstance,'PPLOGO_MASK');
  Mask.PixelFormat:=pf8bit;
  Back:=TBitmap.Create;
  with Back do begin
    Width:=INTROSIZEX; Height:=INTROSIZEY;
    PixelFormat:=pf24bit;
    Canvas.CopyRect(Rect(0,0,INTROSIZEX,INTROSIZEY),Self.Canvas,
                    Rect(0,0,INTROSIZEX,INTROSIZEY));                                             
  end;
  BMP:=TBitmap.Create;
  with BMP do begin
    Width:=INTROSIZEX; Height:=INTROSIZEY;
    PixelFormat:=pf24bit;
  end;
  Phase:=0;
  AnimationTimer.Enabled:=true;
end;

procedure TIntroForm.FormHide(Sender: TObject);
begin
  AnimationTimer.Enabled:=false;
  BMP.Free;
  Back.Free;
  Mask.Free;
  Image.Free;
  PreviewForm.Show;
end;

procedure TIntroForm.RenderTrans(Alpha:integer);
var X,Y,A,N:integer; L:PByteArray;
    Pb,Pm,Pi,Pd:^byte;
begin
  for Y:=0 to (INTROSIZEY-1) do begin
    L:=Back.ScanLine[Y]; Pb:=@L[0];
    L:=Mask.ScanLine[Y]; Pm:=@L[0];
    L:=Image.ScanLine[Y]; Pi:=@L[0];
    L:=BMP.ScanLine[Y]; Pd:=@L[0];
    for X:=0 to (INTROSIZEX-1) do begin
      A:=Pm^; inc(Pm);
      A:=Alpha*(A+(A SHR 7));
      N:=65536-A;
      Pd^:=(Pb^*N+Pi^*A) SHR 16; inc(Pb); inc(Pi); inc(Pd);
      Pd^:=(Pb^*N+Pi^*A) SHR 16; inc(Pb); inc(Pi); inc(Pd);
      Pd^:=(Pb^*N+Pi^*A) SHR 16; inc(Pb); inc(Pi); inc(Pd);
    end;
  end;
  Rendered:=true; Invalidate;
end;

procedure TIntroForm.AnimationTimerTimer(Sender: TObject);
begin
  inc(Phase,8);
  if Phase>256 then RenderTrans(256) else RenderTrans(Phase);
  if Phase>400 then begin
    AnimationTimer.Enabled:=false;
    Hide;
  end;
end;

procedure TIntroForm.FormPaint(Sender: TObject);
begin
  if Rendered then Canvas.Draw(0,0,BMP);
end;

procedure TIntroForm.FormEraseBackground(var msg:TMessage);
begin msg.Result:=0; end;

end.
