unit MMExport;
interface
uses SysUtils, Dialogs, PSTools, PPControl;

var MMExEqualMargins:boolean=true;
    MMExThinLineWidth:double=0.12;
    MMExThickLineWidth:double=0.5;
    MMExLineColor:double=0.5;

procedure DoMMExport(const FileName:string);

implementation
uses Preview;

const LogoSize=28;
      LogoCenter=LogoSize DIV 2;
const MainFontSize=10;
      NumberFontSize=8;
const Copyright='1997-2002 Martin J. Fiedler';
      EMail='martin.fiedler@gmx.net';
      WWW='http://www-user.tu-chemnitz.de/~mfie/';
const FONTHEIGHTFACTOR=0.725;

procedure DoMMExport(const FileName:string);
var MyMarginX,MyMarginY:integer;
begin
  if (SizeX<1) OR (SizeY<1) then exit;
  if not CreatePS(FileName,[psPageSize,psANSI,psPPLogo,psTextTools]) then begin
    MessageDlg('Konnte Datei'^M#34+FileName+#34^M'nicht schreiben!',mtError,[mbOK],0);
    exit;
  end;
  if MMExEqualMargins then begin
    if MarginX>MarginY then begin
      MyMarginX:=MarginX; MyMarginY:=MarginX;
    end else begin
      MyMarginX:=MarginY; MyMarginY:=MarginY;
    end;
  end else begin
    MyMarginX:=MarginX; MyMarginY:=MarginY;
  end;
  writeln(PS,'/Helvetica /Helvetica-ANSI ANSIEncode');
  writeln(PS,'/Helvetica-BoldOblique /Helvetica-BoldOblique-ANSI ANSIEncode');
  writeln(PS,'/mm 72 25.4 div def /five mm 5 mul def');
  NextPage;
  writeln(PS,MyMarginX+LogoSize,#32,PageSizeY-MyMarginY-LogoSize,' translate');
  writeln(PS,'gsave ',LogoCenter,' dup dup neg exch translate dup scale DrawPaperPicLogo grestore');
  writeln(PS,'/Helvetica-BoldOblique-ANSI findfont ',MainFontSize,' scalefont setfont');
  writeln(PS,'0 ',LogoSize-MainFontSize*FONTHEIGHTFACTOR:0:1,' moveto (PaperPic-Millimeterpapierbogen) show');
  writeln(PS,'/Helvetica-ANSI findfont ',MainFontSize,' scalefont setfont');
  writeln(PS,MainFontSize,' 0 rmoveto (Auflsung: ',SizeX,'x',SizeY,' Pixel = ',SizeX*0.1:0:1,'x',SizeY*0.1:0:1,' cm) show');
  writeln(PS,'gsave 90 rotate 0 ',LogoSize-MainFontSize*FONTHEIGHTFACTOR:0:1,' moveto');
  writeln(PS,'(PaperPic III \251 ',Copyright,' \225 E-Mail: ',EMail,' \225 ',WWW,')');
  writeln(PS,'right grestore');
    writeln(PS,'/Helvetica-ANSI findfont 8 scalefont setfont');
  writeln(PS,'gsave five 2 div 3 translate 0 1 ',(SizeX-1) DIV 5,' { 0 0 moveto');
  writeln(PS,'mk2text center five 0 translate } for grestore');
  writeln(PS,'gsave -3 five ',FONTHEIGHTFACTOR*NumberFontSize:0:3,' add 2 div neg translate 0 1 ',(SizeY-1) DIV 5,' { 0 0 moveto');
  writeln(PS,'mk2text right 0 five neg translate } for grestore');
  writeln(PS,FloatToStr(MMExLineColor),' setgray');
  writeln(PS,'/SetWidth{dup 5 mod 0 eq exch max eq or{',FloatToStr(MMExThickLineWidth),
             '}{',FloatToStr(MMExThinLineWidth),'}ifelse setlinewidth}def');
  writeln(PS,'gsave /max ',SizeX,' def /toy ',SizeY,' mm mul neg def');
  writeln(PS,'0 1 max { SetWidth 0 0 moveto 0 toy lineto stroke mm 0 translate } for grestore');
  writeln(PS,'gsave /max ',SizeY,' def /tox ',SizeX,' mm mul def');
  writeln(PS,'0 1 max { SetWidth 0 0 moveto tox 0 lineto stroke 0 mm neg translate } for grestore');
  writeln(PS,'showpage');
  ClosePS;
end;

end.
