unit OPTNmm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, MMExport;

type
  TOPTNmmForm = class(TForm)
    BCancel: TBitBtn;
    BOK: TBitBtn;
    CEqualMargins: TCheckBox;
    CThinLineWidth: TTrackBar;
    CThickLineWidth: TTrackBar;
    LLineWidth: TLabel;
    LThin: TLabel;
    LThick: TLabel;
    VThinLineWidth: TLabel;
    VThickLineWidth: TLabel;
    LLineColor: TLabel;
    CLineColor: TTrackBar;
    PLineColor: TPanel;
    VLineColor: TLabel;
    LGray: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CThinLineWidthChange(Sender: TObject);
    procedure CThickLineWidthChange(Sender: TObject);
    procedure CLineColorChange(Sender: TObject);
    procedure BOKClick(Sender: TObject);
  private
    { Private declarations }
    procedure LoadSettings;
  public
    { Public declarations }
    FileName:string;
  end;

var
  OPTNmmForm: TOPTNmmForm;

implementation

{$R *.dfm}

procedure TOPTNmmForm.FormShow(Sender: TObject);
begin
  LoadSettings;
end;

procedure TOPTNmmForm.LoadSettings;
begin
  CEqualMargins.Checked:=MMExEqualMargins;
  CThinLineWidth.Position:=round(MMExThinLineWidth*100.0);
  CThinLineWidthChange(nil);
  CThickLineWidth.Position:=round(MMExThickLineWidth*100.0);
  CThickLineWidthChange(nil);
  CLineColor.Position:=round((1.0-MMExLineColor)*100.0);
  CLineColorChange(nil);
end;

procedure TOPTNmmForm.CThinLineWidthChange(Sender: TObject);
begin
  VThinLineWidth.Caption:=Format('%4.2f pt',[CThinLineWidth.Position*0.01]);
end;

procedure TOPTNmmForm.CThickLineWidthChange(Sender: TObject);
begin
  VThickLineWidth.Caption:=Format('%4.2f pt',[CThickLineWidth.Position*0.01]);
end;

procedure TOPTNmmForm.CLineColorChange(Sender: TObject);
var i:integer;
begin
  i:=CLineColor.Position;
  VLineColor.Caption:=IntToStr(i)+'%';
  i:=100-i;
  if i>50 then PLineColor.Font.Color:=clBlack else PLineColor.Font.Color:=clWhite;
  i:=round(i*2.55);
  PLineColor.Color:=(i SHL 16) OR (i SHL 8) OR i;
end;

procedure TOPTNmmForm.BOKClick(Sender: TObject);
begin
  MMExEqualMargins:=CEqualMargins.Checked;
  MMExThinLineWidth:=CThinLineWidth.Position*0.01;
  MMExThickLineWidth:=CThickLineWidth.Position*0.01;
  MMExLineColor:=1.0-CLineColor.Position*0.01;
  DoMMExport(FileName);
end;

end.
