{class=Programm}
{desc1=PaperPic V2 - voll-grafisch}
program PaperPicV2;
uses crt,vgagraph,dos;

{  VEREINBARUNGSTEIL }

{$DEFINE Lang_de}

{  KONSTANTEN }
const titlex='PaperPic V2.11$  (C) 1998 Martin Fiedler';
                 { Klarer Fall: die Titelzeile - das Dollarz. wird durch den
                 Lndercode ersetzt                                         }
      MaximumPictureSize=250;                          { maximale Bildgre }
      MaximumPaletteEntries=127;                            { Palettengre }
      RegNo='1C86-A22F-84E5-607F';                       { Registriernummer }
      RegDelInc=12;   { RMD-Verlngerung nach jedem Start in 55ms-Schritten }

const maxpal=maximumpaletteentries;
      maxresx=maximumpicturesize;maxresy=maximumpicturesize;
type TPixel=array[1..3]of byte;                    { RGB-Werte eines Pixels }
     TIntPixel=array[1..3]of integer;  { RGB-Werte eines Pixels als Integer }

     TLine=array[0..maxresx+1]of byte;                    { eine Byte-Zeile }
     TPage=array[0..maxresy+1]of TLine;                   { eine Byte-Seite }
     PPage=^TPage;                             { Zeiger auf eine Byte-Seite }

     TPixelArray=array[1..maxpal]of TPixel;   { eine Palette Byte-RGB-Werte }
     TIntPixelArray=array[1..maxpal]of TIntPixel;   { Pal. mit Integer-RGBs }
     TByteArray=array[1..maxpal]of byte;     { Byte-Palette (fr Zuordnung) }
     TCharArray=array[1..maxpal]of char;     { Char-Palette (fr Zuordnung) }
     TWordArray=array[1..maxpal]of word;    { Word-Palette (fr Auszhlung) }
     TStr64Array=array[1..maxpal]of string[63];  { Str.-Palette (fr Namen) }

     TColorEntry=record           { ein einzelner Eintrag in der Farbliste: }
                   name:string[45];                            { Farbname }
                   look,active:char;    { Erkennungszeigen, aktiv ja/nein }
                   color:tpixel;                          { RGB-Farbwerte }
                 end;
     TColorTable=array[1..maxpal]of TColorEntry;      { gesamte Farbpalette }
     TPreset=array[1..255]of char;                { einzelne Preset-Palette }
     TPresetArray=array[0..9]of TPreset;          { alle 10 Preset-Paletten }

     FontType=array[char,0..31]of byte;               { Zeichensatzspeicher }
     FileList=array[0..63]of string[10];               { Dateiauswahl-Liste }

const empty:tcolorentry=(name:'-';look:#32;active:#250;color:(0,0,0));
                                                       { Leerer Farbeintrag }
{$I PAPERPIC.LGO}
  { Das PaperPic-Logo wurde aus bersichtlichkeitsgrnden ausgelagert }

{$IFDEF Lang_de} {$I PAPERPIC._DE} {$ENDIF}
{$IFDEF Lang_en} {$I PAPERPIC._EN} {$ENDIF}
{$IFDEF Lang_fr} {$I PAPERPIC._FR} {$ENDIF}
  { Sprachressourcen laden }

var vgafont:fonttype absolute $A000:0;fnt:fonttype;          { Font-Technik }
    f:file;                                           { Variablen fr alles }
    x,y,i:integer;
    l,li,ramfree:longint;
    a,b,z:byte;
    vm,w1,w2:word;
    fc,ic:char;
    menex:boolean;
    s1,s2,st80,e80,pols:string;
    di0,di1,di2,di3:integer;  { Debugvariablen }
    title:string[79];                      { der konstruierte Programmtitel }

    gmv:byte;                                 { die globale Modusvariable }
    stat:shortint; { -1 = Fehler; 0 = ungeladen; 1 = geladen; 2 = berechnet }
    err:string;                              { Fehlermeldung bei Berechnung }
    lisi:word;line:array[1..maxresx+1]of tpixel;         { zum BMP-Einlesen }
    rb,gb,bb,pp:PPage;                               { die drei Framebuffer }
    rv,gv,bv,ppv:byte;           { RGB- und PP-Farbwerte whrend Berechnung }
    xs,ys,xo,yo:word;                           { X-/Y-Gre und Bildoffset }
    num,anz:twordarray;                               { Pixelzahl pro Farbe }
    usco:integer;                      { Anzahl effektiv verwendeter Farben }

    mc:byte;                                                   { Farbanzahl }
    wp:tintpixelarray;                                     { Arbeitspalette }
    wc:tbytearray;                               { konvertierte Zielzeichen }
    ass:tbytearray;                                       { Zuordnungsliste }
    alt,neu,dif:tintpixel;                        { fr die Error Diffusion }
    fct:real;                                     { fr die Prozentrechnung }
    toplin:string;                         { Zeile am oberen Bildschirmrand }
    sr:searchrec;fl:filelist;                        { fr die Dateiauswahl }

    fina:string;                                      { aktueller Dateiname }
    obri,bri:integer;                   { Bildhelligkeit in 100/128 Prozent }
    lpp:word;                       { Zeilen pro Seite (berrest aus V1.xx) }
    preformat:boolean;                            { Vorformatierung ein/aus }
    coltab:tcolortable;                                       { Farbtabelle }
    clipboard,swapcol:tcolorentry;                         { Clipboard-Wert }
    co1,co2:twordarray;   { vorberechnete 16-Bit-Farbwerte fr die Farben }
    pre:tpresetarray;                                { die 10 Preset-Arrays }
    zoom:boolean;                                         { 2x-Zoom ein/aus }
    rota:byte;                            { Rotationsstufe in 90-Schritten }
    pmh,pmv:boolean;                       { Horizontal / Vertikal spiegeln }
    cp,vp:integer;                   { Cursor-/View-Position in Farbtabelle }

    timer:longint absolute $0040:$006C;              { Timertechnik fr RMD }
    st,rt,nt:longint;


{  HILFSPROZEDUREN }
procedure fontmode;assembler;asm;mov dx,3C4h;mov ax,0100h;out dx,ax;
  mov ax,0402h;out dx,ax;mov ax,0704h;out dx,ax;mov ax,0300h;out dx,ax;
  mov dx,3CEh;mov ax,0204h;out dx,ax;mov ax,0005h;out dx,ax;mov ax,0406h;
  out dx,ax;end;  { FONTMODE - zum Auslesen des VGA-Zeichensatzes }
procedure xwrite(px,py:integer;tex:string;fc,bc:word);var cp,ml:byte;cc:char;
  yp,xp,ya,sp:integer;dc:word;begin;yp:=py;ml:=byte(tex[0]);
  for ya:=0 to 15 do begin;sp:=0;cp:=1;xp:=px SHL 1;repeat;asm;mov ah,&cp;
  cmp ah,1;jnz @samechar;mov si,&sp;inc si;mov &sp,si;
  mov al,byte ptr tex+[si];mov &cc,al;@samechar:ror ah,1;mov &cp,ah;
  mov bl,byte ptr &cc;xor bh,bh;shl bx,5;mov di,&ya;add di,bx;
  mov al,byte ptr fnt+[di];test al,ah;jz @backgc;mov ax,&fc;jmp @weiter;
  @backgc:mov ax,&bc;@weiter:mov &dc,ax;mov ax,1280;mul &yp;add ax,&xp
  adc dx,0;cmp dl,&cbank;jz @malen;mov &cbank,dl;push ax;xor bx,bx;
  mov ax,4F05h;int 10h;pop ax;@malen:mov di,0A000h;mov es,di;mov di,ax
  mov ax,&dc;mov es:[di],ax;add &xp,2;end;until (cp=1) AND (sp=ml);inc(yp);
  end;end;  { XWrite schreibt HiColor-Zeichen }
procedure back(x1,y1,x2,y2:integer);var x,y,dx:integer;typ,txp,tmb:byte;
  dc:word;begin;dx:=x2 SHL 1;typ:=63-(y1 AND 63);for y:=y1 to y2 do begin;
  txp:=(x1 SHR 3)MOD 40;tmb:=1 SHL (7-(x1 AND 7));asm;mov ax,&x1;shl ax,1;
  @xloop:mov &x,ax;mov ax,40;mul &typ;add al,&txp;adc ah,0;mov di,ax;
  mov al,byte ptr pplogo+[di];mov bx,20;mov cx,&x;add cx,&y;and cx,7;
  shr cx,1;sub bx,cx;test al,&tmb;jnz @zum_malen;sub bx,8;@zum_malen:
  mov &dc,bx;mov ax,1280;mul &y;add ax,&x;adc dx,0;cmp dl,&cbank;jz @malen;
  mov &cbank,dl;push ax;xor bx,bx;mov ax,4F05h;int 10h;pop ax;@malen:
  mov di,0A000h;mov es,di;mov di,ax;mov ax,&dc;mov es:[di],ax;mov al,&tmb;
  ror al,1;mov &tmb,al;test al,128;jz @nextcol;xor ah,ah;mov al,&txp;inc al;
  mov bl,40;div bl;mov &txp,ah;@nextcol:mov ax,&x;add ax,2;cmp ax,&dx;
  jna @xloop;end;typ:=(typ-1)AND 63;end;end;  { Background-Bereichsfllung }
procedure cost80(ips:string);var b:byte;begin st80:=e80;b:=byte(ips[0]);
  if b=0 then exit;if b>80 then b:=80;move(ips[1],st80[1],b);end;
    { ST80 konstruieren }
procedure topline(ips:string);var b:byte;begin st80:=e80;b:=byte(ips[0]);
  if b<>0 then begin if b>80 then b:=80;move(ips[1],st80[80-b],b);end;
  xwrite(0,16,st80,$C7E0,21);end;
    { Titelzeile schreiben }
function input(xp,yp:integer;os:string;epl:byte;fc,bc:word):string;
  { Eingaberoutine mit XWrite }
var sc:char;le,ml:byte;s:string;
begin
  s:=os;le:=byte(s[0]);
  repeat
    st80:=e80;st80[0]:=char(epl);
    if le>0 then move(s[1],st80[1],le);
    st80[le+1]:='_';
    xwrite(xp,yp,st80,fc,bc);
    sc:=readkey;
    if sc=#0 then begin sc:=readkey;
      if sc=#83 then le:=0;
      sc:=#0;
    end;
    if (sc=#8) AND (le>0) then dec(le);
    if (sc>#31) AND (le<epl-1) then begin inc(le);s[le]:=sc;end;
    s[0]:=char(le);
    if sc=#27 then begin s:=os;sc:=#13;end;
  until sc=#13;
  st80:=e80;st80[0]:=char(epl);
  if le>0 then move(s[1],st80[1],le);
  xwrite(xp,yp,st80,fc,bc);
  input:=s;
end;
procedure wlin(li:string);begin pols:=li+^M^J;
  blockwrite(f,pols[1],byte(pols[0]));end;
    { Zeile in Datei F ausgeben }

{  PROGRAMMTEILE }
procedure quitprogram;  { Programm beenden }
begin
  if rt>0 then inc(rt,regdelinc);
  assign(f,'PAPERPIC.CFG');rewrite(f,1);
  blockwrite(f,fina,sizeof(fina));
  blockwrite(f,bri,sizeof(bri));
  blockwrite(f,lpp,sizeof(lpp));
  blockwrite(f,preformat,sizeof(preformat));
  blockwrite(f,clipboard,sizeof(clipboard));
  blockwrite(f,pre,sizeof(pre));
  blockwrite(f,zoom,sizeof(zoom));
  blockwrite(f,rota,sizeof(rota));
  blockwrite(f,pmh,sizeof(pmh));
  blockwrite(f,pmv,sizeof(pmv));
  inc(rt,1000);blockwrite(f,rt,sizeof(rt));
  blockwrite(f,cp,sizeof(cp));
  blockwrite(f,vp,sizeof(vp));
  blockwrite(f,coltab,sizeof(coltab));
  close(f);
  closegraph;
  ramfree:=memavail;
  dispose(pp);dispose(bb);dispose(gb);dispose(rb);
  textattr:=$03;write(title,^M^J^J);textattr:=$07;
end;

procedure startup;  { Initialisierung }
begin
  l:=memavail;
  if l<sizeof(pp^)*4 then begin write(qOutOfMem);
  halt;end;
  new(rb);new(gb);new(bb);new(pp);
  title:=titlex;b:=pos('$',title);
  delete(title,b,1);insert(langcode,title,b);
  fillchar(e80,81,32);e80[0]:=#80;
  toplin:='PP 0    1    2    3    4    5    6    7    8    9    10   11 '+
          '  12   13   14   15   16   17   18   19   20   21   22   23  '+
          ' 24   25   26   27   28   29   30   31   32   33   34   35   '+
          '36   37   38   39   40   41   42   43   44   45   46   47   4'+
          '8   49   ';
  initvesa;
  vm:=getvesamode(640,480,16);
  if vm=0 then begin write(qNoVESA);
  halt;end;
  fontmode;fnt:=vgafont;
  setvesamode(vm);
  xwrite(0,464,'1       2       3       4       5       6       7       8  '+
               '     9       10',$F800,0);
  xwrite(8,464,qBar1,19,$A4D2);
  xwrite(72,464,qBar2,19,$A4D2);
  xwrite(136,464,qBar3,19,$A4D2);
  xwrite(200,464,qBar4,19,$A4D2);
  xwrite(264,464,qBar5,19,$A4D2);
  xwrite(328,464,qBar6,19,$A4D2);
  xwrite(392,464,qBar7,19,$A4D2);
  xwrite(456,464,qBar8,19,$A4D2);
  xwrite(520,464,qBar9,19,$A4D2);
  xwrite(592,464,qBar0,19,$A4D2);
  cost80(#32+title);
  for b:=0 to 79 do begin
    w1:=calchi(255-b,255-b*3,b*2);
    w2:=calchi(b*2,b*3,b);
    x:=b SHL 3;
    xwrite(x,0,st80[b+1],w1,w2);
  end;
end;

procedure calcco(nr:byte);  { Farbe fr CO1-/CO2-Array-Kombi berechnen }
var vn,n:byte;
begin
  rv:=coltab[nr].color[1];
  gv:=coltab[nr].color[2];
  bv:=coltab[nr].color[3];
  co1[nr]:=calchi(rv,gv,bv);

  vn:=rv SHR 3;n:=(vn SHL 3)OR (vn SHR 2);
  if n>rv then begin if (n-rv)>4 then dec(rv,8);end
          else begin if (rv-n)>4 then inc(rv,8);end;

  vn:=gv SHR 2;n:=(vn SHL 2)OR (vn SHR 4);
  if n>gv then begin if (n-gv)>2 then dec(rv,4);end
          else begin if (gv-n)>2 then inc(rv,4);end;

  vn:=bv SHR 3;n:=(vn SHL 3)OR (vn SHR 2);
  if n>bv then begin if (n-bv)>4 then dec(bv,8);end
          else begin if (bv-n)>4 then inc(bv,8);end;

  co2[nr]:=calchi(rv,gv,bv);
end;

procedure config;  { Konfiguration laden }
begin
  for i:=1 to maxpal do coltab[i]:=empty;
  assign(f,'PAPERPIC.CFG'); {$I-} reset(f,1); {$I+}
  if ioresult=0 then begin
    blockread(f,fina,sizeof(fina),w);
    blockread(f,bri,sizeof(bri),w);
    blockread(f,lpp,sizeof(lpp),w);
    blockread(f,preformat,sizeof(preformat),w);
    blockread(f,clipboard,sizeof(clipboard),w);
    blockread(f,pre,sizeof(pre),w);
    blockread(f,zoom,sizeof(zoom),w);
    blockread(f,rota,sizeof(rota),w);
    blockread(f,pmh,sizeof(pmh),w);
    blockread(f,pmv,sizeof(pmv),w);
    blockread(f,rt,sizeof(rt),w);dec(rt,1000);
    blockread(f,cp,sizeof(cp),w);
    blockread(f,vp,sizeof(vp),w);
    blockread(f,coltab,sizeof(coltab),w);
    close(f);
  end else begin
    fina:='PaperPic';bri:=128;lpp:=300;preformat:=true;clipboard:=empty;
    fillchar(pre,sizeof(pre),250);
    for b:=0 to 9 do begin pre[b,1]:=#254;pre[b,2]:=#254;end;
    zoom:=false;rota:=0;pmh:=false;pmv:=false;rt:=48;cp:=0;vp:=1;
    coltab[1].name:=qForceColBlack;coltab[1].active:=#254;
    coltab[2].name:=qForceColWhite;coltab[2].active:=#254;
      coltab[2].color[1]:=255;coltab[2].color[2]:=255;coltab[2].color[3]:=255;
  end;
  for i:=1 to maxpal do calcco(i);
end;

procedure rotate;  { Bild drehen }
procedure ro(bu:ppage);
begin
  for x:=1 to ys do for y:=1 to xs do
    pp^[y,x]:=bu^[ys-x+1,y];
  bu^:=pp^;
end;
begin
  ro(rb);ro(gb);ro(bb);
  w:=xs;xs:=ys;ys:=w;
end;

procedure flip;  { Bild auf den Kopf stellen }
var cc1,cc2:integer;
begin
  for y:=0 to ((ys-1) SHR 1) do begin
    cc1:=y+1;cc2:=ys-y;
    for x:=1 to xs do begin
      rv:=rb^[cc1,x];rb^[cc1,x]:=rb^[cc2,x];rb^[cc2,x]:=rv;
      gv:=gb^[cc1,x];gb^[cc1,x]:=gb^[cc2,x];gb^[cc2,x]:=gv;
      bv:=bb^[cc1,x];bb^[cc1,x]:=bb^[cc2,x];bb^[cc2,x]:=bv;
    end;
  end;
end;

procedure mirror;  { Bild spiegeln }
var cc1,cc2:integer;
begin
  for x:=0 to ((xs-1) SHR 1) do begin
    cc1:=x+1;cc2:=xs-x;
    for y:=1 to ys do begin
      rv:=rb^[y,cc1];rb^[y,cc1]:=rb^[y,cc2];rb^[y,cc2]:=rv;
      gv:=gb^[y,cc1];gb^[y,cc1]:=gb^[y,cc2];gb^[y,cc2]:=gv;
      bv:=bb^[y,cc1];bb^[y,cc1]:=bb^[y,cc2];bb^[y,cc2]:=bv;
    end;
  end;
end;

procedure reload;  { Bild laden }
var xh,xv:boolean;
begin
  fillchar(line,sizeof(line),0);{ bei BMP-Fehlern schwarze Zeilen schreiben }
  fillchar(rb^,sizeof(rb^),0);                    { Farbplanebuffer lschen }
  fillchar(gb^,sizeof(gb^),0);
  fillchar(bb^,sizeof(bb^),0);
  stat:=1;err:='';
  assign(f,fina+'.BMP');
  {$I-} reset(f,1); {$I+}
  if ioresult<>0 then begin err:=qErrNotExist;stat:=-1;exit;end;
  seek(f,28);blockread(f,b,1,w);        { Farbtiefe der BMP-Datei auslesen }
  seek(f,18);blockread(f,xs,2,w);                  { BMP-Bildgre auslesen }
  seek(f,22);blockread(f,ys,2,w);
  if xs>maxresx then begin err:=qErrTooWide;stat:=-1;end;
                                                     { Bild zu breit? RAUS! }
  if ys>maxresy then begin err:=qErrTooHigh;stat:=-1;end;
                                                      { Bild zu hoch? RAUS! }
  if b<>24 then begin err:=qErrNoTrueColor;stat:=-1;end;
                                                  { Keine 24-Bit-BMP? RAUS! }
  if stat=-1 then begin
    close(f);exit;
  end;
  seek(f,54);                           { zum wirklichen Bildstart "fahren" }
  lisi:=xs*3+(xs AND 3);                { Zeilenlnge in der BMP ausrechnen }
  for y:=ys downto 1 do begin   { Los geht's: zeilenweises Einlesen der BMP }
    blockread(f,line,lisi,w);                         { eine Zeile einlesen }
    if bri>128 then begin                      { Helligkeit grer als 100% }
      w:=bri-128;              { wirklichen Skalierungsfaktor ausrechnen }
      for x:=1 to xs do begin               { und jedes Pixel durchgehen: }
        rv:=line[x,3]+((255-line[x,3])*w)SHR 7;  { Farbanteile multipli- }
        gv:=line[x,2]+((255-line[x,2])*w)SHR 7;                 { zieren }
        bv:=line[x,1]+((255-line[x,1])*w)SHR 7;
        rb^[y,x]:=rv;gb^[y,x]:=gv;bb^[y,x]:=bv;    { im Bufffer speichern }
      end;
    end else begin                       { Helligkeit doch kleiner als 100% }
      for x:=1 to xs do begin                   { jedes Pixel durchgehen: }
        w:=bri;
        rv:=(line[x,3]*w)SHR 7;               { Farbanteile durchmulti- }
        gv:=(line[x,2]*w)SHR 7;                             { plizieren }
        bv:=(line[x,1]*w)SHR 7;
        rb^[y,x]:=rv;gb^[y,x]:=gv;bb^[y,x]:=bv;   { und im Buffer ablegen }
      end;
    end;
  end;
  close(f);                                    { BMP-Datei wieder schlieen }
  xh:=pmh;xv:=pmv;
  if (rota AND 1)<>0 then rotate;
  if (rota AND 2)<>0 then begin xh:=not(xh);xv:=not(xv);end;
  if xh then flip;
  if xv then mirror;
end;

procedure diffuse(px,py:word;fac:integer);  { eine Aufteilungsoperation der }
begin                                                     { Error Diffusion }
  i:=rb^[py,px]+dif[1]*fac DIV 16;
  if i<0 then i:=0;if i>255 then i:=255;
  rb^[py,px]:=i;
  i:=gb^[py,px]+dif[2]*fac DIV 16;
  if i<0 then i:=0;if i>255 then i:=255;
  gb^[py,px]:=i;
  i:=bb^[py,px]+dif[3]*fac DIV 16;
  if i<0 then i:=0;if i>255 then i:=255;
  bb^[py,px]:=i;
end;

procedure recalc;  { Bild berechnen }
var df,mdf:integer;
begin
  fillchar(num,sizeof(num),0);
  fillchar(anz,sizeof(anz),0);
  fillchar(pp^,sizeof(pp^),0);
  mc:=0;
  for i:=1 to maxpal do if coltab[i].active=#254 then begin
    inc(mc);ass[mc]:=i;
    wp[mc,1]:=coltab[i].color[1];
    wp[mc,2]:=coltab[i].color[2];
    wp[mc,3]:=coltab[i].color[3];
    wc[mc]:=byte(coltab[i].look);
  end;
  if mc=0 then begin err:=qNoColorsSelected;stat:=-1;exit;end;
  for y:=1 to ys do for x:=1 to xs do begin
    alt[1]:=rb^[y,x];alt[2]:=gb^[y,x];alt[3]:=bb^[y,x];
    ppv:=0;mdf:=32000;b:=0;
    repeat
      inc(b);
      df:=abs(alt[1]-wp[b,1])+abs(alt[2]-wp[b,2])+abs(alt[3]-wp[b,3]);
      if df<mdf then begin mdf:=df;ppv:=b;end;
    until (b=mc) OR (df=0);
    pp^[y,x]:=wc[ppv];
    inc(num[ppv]);
    neu:=wp[ppv];
    dif[1]:=alt[1]-neu[1];dif[2]:=alt[2]-neu[2];dif[3]:=alt[3]-neu[3];
    rb^[y,x]:=neu[1];gb^[y,x]:=neu[2];bb^[y,x]:=neu[3];
    diffuse(x+1,y,7);
    diffuse(x-1,y+1,3);
    diffuse(x,y+1,5);
    diffuse(x+1,y+1,1);
  end;
  for i:=1 to mc do anz[ass[i]]:=num[i];
  num:=anz;for i:=1 to maxpal do ass[i]:=i;
  for x:=1 to maxpal-1 do
    for y:=x+1 to maxpal do
      if num[x]<num[y] then begin
        w:=num[x];num[x]:=num[y];num[y]:=w;
        b:=ass[x];ass[x]:=ass[y];ass[y]:=b;
      end;
  if num[maxpal]<>0 then usco:=maxpal else begin
    usco:=maxpal;repeat;dec(usco);until num[usco]<>0;
  end;
  stat:=2;
end;

procedure hiprev_norm;  { HiColor-Preview ohne Zoom }
begin
  xo:=(640-xs)SHR 1;yo:=(440-ys)SHR 1;
  for y:=1 to ys do for x:=1 to xs do
    putpixhi(x+xo,y+yo,rb^[y,x],gb^[y,x],bb^[y,x]);
end;

procedure hiprev_zoom;  { HiColor-Preview mit Zoom }
var lx,ly:word;
begin
  i:=220-ys;
  if i>32 then ly:=i else ly:=32;
  i:=(431-ly)SHR 1;
  if i>ys then yo:=ys else yo:=i;
  xo:=320-xs;
  for y:=1 to ys do begin
    lx:=xo;
    for x:=1 to xs do begin
      rv:=rb^[y,x];gv:=gb^[y,x];bv:=bb^[y,x];
      putpixhi(lx,ly,rv,gv,bv);
      putpixhi(lx+1,ly,rv,gv,bv);
      putpixhi(lx,ly+1,rv,gv,bv);
      putpixhi(lx+1,ly+1,rv,gv,bv);
      inc(lx,2);
    end;
    inc(ly,2);
  end;
end;

function brightness:string;  { neue Helligkeit anzeigen }
begin
  str((bri/1.28)-100.0:0:2,s1);
  if bri>128 then s1:='+'+s1+'%'
             else s1:=s1+'%';
  if bri=128 then brightness:=qOriginalBrightness
             else brightness:=s1;
end;

procedure cswc(nr,pos:byte;hilite:boolean);  { Farbauswahl-Eintrag zeichnen }
var tfc,tbc,ty:word;
begin
  if hilite then begin tfc:=$FFFF;tbc:=$0415;end
            else begin tfc:=$C618;tbc:=$000E;end;
  ty:=48+pos SHL 4;
  str(nr:4,s1);
  xwrite(0,ty,s1+'  '+coltab[nr].look+#32,tfc,tbc);
  s1:=e80;s1[0]:=#62;
  s1[2]:=coltab[nr].active;
  for b:=0 to 9 do s1[52+b]:=pre[b,nr];
  b:=byte(coltab[nr].name[0]);if b>46 then b:=46;
  move(coltab[nr].name[1],s1[5],b);
  xwrite(64,ty,'',co1[nr],co2[nr]);
  xwrite(144,ty,s1,tfc,tbc);
end;

procedure cewc(nr,pos:byte;hilite:boolean);  { Farbeditor-Eintrag zeichnen }
var tfc,tbc,ty:word;
begin
  if hilite then begin tfc:=$FFFF;tbc:=$0415;end
            else begin tfc:=$C618;tbc:=$000E;end;
  ty:=48+pos SHL 4;
  str(nr:4,s1);
  xwrite(0,ty,s1+'  '+coltab[nr].look+#32,tfc,tbc);
  str(coltab[nr].color[1]:53,s1);
  str(coltab[nr].color[2]:6,s2);s1:=s1+s2;
  str(coltab[nr].color[3]:6,s2);s1:=s1+s2+'  ';
  b:=byte(coltab[nr].name[0]);if b>46 then b:=46;
  move(coltab[nr].name[1],s1[3],b);
  xwrite(64,ty,'',co1[nr],co2[nr]);
  xwrite(104,ty,s1,tfc,tbc);
end;

procedure colorimport;  { Farbdatei PAPERPIC.COL importieren }
begin
  xwrite(180,200,qReallyImport,$0000,$FFFF);
  ic:=upcase(readkey);
  if ic='N' then begin ic:=#0;exit;end;
  ic:=#0;
  assign(f,'PAPERPIC.COL'); {$I-} reset(f,1); {$I+}
  if ioresult<>0 then exit;
  blockread(f,l,4,w);i:=cp+vp-1;
  while not eof(f) do begin
    inc(i);if i>maxpal then i:=maxpal;
    blockread(f,s1,59,w);
    coltab[i].name:=s1;
    blockread(f,coltab[i].look,1,w);
    blockread(f,b,1,w);
    coltab[i].active:=char(250+b SHL 2);
    blockread(f,coltab[i].color,3,w);
    calcco(i);
  end;
  close(f);
end;

procedure save;  { Bild speichern }
begin
  if stat<>2 then exit;
  fct:=100.0/(xs*ys);
  assign(f,fina+'.PP1');rewrite(f,1);
  if preformat then begin
    st80:=toplin;st80[0]:=char(xs+3);wlin(st80);
  end;
  st80[0]:=char(xs);
  for y:=1 to ys do begin
    move(pp^[y,1],st80[1],xs);
    if preformat then begin
      if y MOD 5=1 then begin
        str((y-1)DIV 5:2,s1);s1:=s1+#32;
      end else s1:='   ';
      wlin(s1+st80);
    end else wlin(st80);
  end;
  close(f);
  assign(f,fina+'.PPL');rewrite(f,1);
  wlin(qSaveLegend);
  str((xs*0.1):0:1,s1);str((ys*0.1):0:1,s2);
  cost80('  *  '+qSavePictureSize+s1+' cm x '+s2+' cm');
  st80[0]:=#51;str(xs*ys:5,s1);
  wlin(st80+s1+' '+qPixels+' = 100.00% ');
  for i:=1 to usco do begin
    x:=ass[i];w:=anz[x];
    s1:='     '+coltab[x].name;s1[3]:=coltab[x].look;
    cost80(s1);st80[0]:=#51;
    str(w:5,s1);str((w*fct):7:2,s2);
    wlin(st80+s1+' '+qPixels+' ='+s2+'% ');
  end;
  close(f);
end;

procedure vtpm(xof,nr,pos:integer);  { PP-Tab.-Zeile mit Preformat zeichnen }
begin
  y:=32+pos SHL 4;
  if nr=0 then st80:=toplin else begin
    if nr MOD 5=1 then begin
      str((nr-1)DIV 5:2,st80);st80[3]:=#32;
    end else st80:='   ';
    move(pp^[nr,1],st80[4],xs);
  end;
  move(st80[xof],s1[1],80);s1[0]:=#80;
  xwrite(0,y,s1,$C618,$000E);
end;

procedure vtnp(xof,nr,pos:integer);  { PP.-Tab.-Zeile ohne Preform. zeichnen }
begin
  y:=32+pos SHL 4;
  move(pp^[nr,xof],s1[1],80);s1[0]:=#80;
  xwrite(0,y,s1,$C618,$000E);
end;

procedure mmupd(was:byte);begin case was of  { Hauptmen-Eintrag zeichnen }
01:begin
     cost80(fina);st80[0]:=#33;st80[33]:=#32;
     xwrite(320,79,st80,$0515,$632C);
   end;
02:if preformat
         then xwrite(320,95,qInfoPreformatOn,$0515,$632C)
         else xwrite(320,95,qInfoNoPreformat,$0515,$632C);
03:begin
     cost80(brightness);st80[0]:=#33;
     xwrite(320,111,st80,$0515,$632C);
   end;
04:xwrite(320,127,qInfoRotationQuarters[rota],$0515,$632C);
05:if pmh
        then xwrite(320,143,qInfoYes,$0515,$632C)
        else xwrite(320,143,qInfoNo,$0515,$632C);
06:if pmv
        then xwrite(320,159,qInfoYes,$0515,$632C)
        else xwrite(320,159,qInfoNo,$0515,$632C);
07:if zoom
        then xwrite(320,175,qInfoZoomX2,$0515,$632C)
        else xwrite(320,175,qInfoZoomX1,$0515,$632C);
08:begin
     case stat of
      -1:s1:=qInfoErr;
       0:s1:=qInfoStat0;
       1:s1:=qInfoStat1;
       2:s1:=qInfoStat2;
     end;
     xwrite(72,289,s1,$0515,$632C);
     if stat=-1 then begin
       s1:=err;dec(s1[0]);
       cost80(s1);st80[0]:=#26;
       xwrite(72,305,st80,$0515,$632C);
     end else xwrite(72,305,'                          ',$0515,$632C);
     if stat>0 then begin
       str(xs,s1);str(ys,s2);
       cost80(s1+' x '+s2+' '+qPixels);st80[0]:=#17;
       xwrite(72,337,st80,$0515,$632C);
       str((xs*0.1):0:1,s1);str((ys*0.1):0:1,s2);
       cost80(s1+' cm x '+s2+' cm');st80[0]:=#17;
       xwrite(72,353,st80,$0515,$632C);
     end else begin
       xwrite(72,337,'-               ',$0515,$632C);
       xwrite(72,353,'                 ',$0515,$632C);
     end;
     if stat=2 then begin
       str(usco,s1);str(mc,s2);
       xwrite(72,385,s1+qOf+s2+' '+qColors+'   ',$0515,$632C);
     end else xwrite(72,385,'-              ',$0515,$632C);
   end;
end;end;

procedure selefile;  { Datei aus Liste auswhlen }
var mf,cx,cy,ox,oy,mx,my,cor:integer;tit:string[19];
begin
  mf:=0;fl[0]:=qFileSelectFirstEntry;
  for b:=1 to 63 do fl[b,0]:=#0;
  findfirst('*.BMP',$27,sr);
  while doserror=0 do begin
    s1:='          ';
    move(sr.name[1],s1[2],byte(sr.name[0])-4);
    if mf<63 then inc(mf);fl[mf]:=s1;
    findnext(sr);
  end;
  if mf>1 then
    for a:=1 to mf-1 do
      for b:=a+1 to mf do
        if fl[a]>fl[b] then begin
          s1:=fl[a];fl[a]:=fl[b];fl[b]:=s1;
        end;
  my:=99;mx:=7;
  for b:=1 to 7 do begin
    cy:=(mf+b)DIV b;cx:=(b*cy)-mf-1;
    if (cy<17) AND (cx<my) then begin my:=cx;mx:=b;end;
  end;
  my:=(mf+mx)DIV mx;cor:=my+1;
  ox:=240-40*mx;oy:=232-my SHL 3;
  if mx=1 then tit:=qFileSelectShortTitle else tit:=qFileSelectLongTitle;
  fillchar(s1,10*mx+1,32);s1[0]:=char(10*mx);
  move(tit[1],s1[(byte(s1[0])-byte(tit[0]))SHR 1+1],byte(tit[0]));
    { sieht kompliziert aus, ist es auch: Titel in die Mitte vom String S1 }
  back(ox+77,oy-3,ox+mx*80+82,oy+my*16+18);
  xwrite(ox+80,oy,s1,$C638,$0415);
  for cy:=1 to my do for cx:=1 to mx do begin
    s1:=fl[cx*my+cy-cor];
    if s1[0]=#0 then s1:='          ';
    xwrite(ox+cx*80,oy+cy*16,s1,$0515,$632C);
  end;
  s1:='          ';b:=byte(fina[0]);if b>8 then b:=8;
  move(fina[1],s1[2],b);
  i:=mf+1;repeat;dec(i);until (i=0) OR (fl[i]=s1);
  cx:=(i DIV my)+1;cy:=(i MOD my)+1;
  repeat
    di2:=mx;di3:=my;
    xwrite(ox+cx*80,oy+cy*16,fl[cx*my+cy-cor],$632C,$0515);
    fc:=#0;ic:=readkey;if ic=#0 then fc:=readkey;
    xwrite(ox+cx*80,oy+cy*16,fl[cx*my+cy-cor],$0515,$632C);
    x:=cx;y:=cy;
    case fc of
      #72:dec(cy);
      #75:dec(cx);
      #77:inc(cx);
      #80:inc(cy);
    end;
    if cx<1 then begin cx:=mx;dec(cy);end;
    if cx>mx then begin cx:=1;inc(cy);end;
    if cy<1 then begin cy:=my;dec(cx);end;
    if cy>my then begin cy:=1;inc(cx);end;
    if (cx<1) OR (cy<1) OR (cx>mx) OR (cy>my) OR (fl[cx*my+cy-cor,0]=#0)
      then begin cx:=x;cy:=y;end;
  until (ic=#13) OR (ic=#27);
  if (ic=#13) AND (cx+cy>2) then begin
    s1:=fl[cx*my+cy-cor];
    b:=9;repeat;dec(b);until s1[b+1]<>#32;
    fina:=copy(s1,2,b);stat:=0;
  end;
  ic:=#0;fc:=#0;
end;


{  MENS }
{  HAUPTMEN }
procedure mainmenu;
begin
  back(0,32,639,463);
  topline(qTopLine2);
  xwrite(56,47,qMenuTitle,$C638,$0415);
  xwrite(56,63,qMenuOptionD,$A515,$632C);
  xwrite(56,79,qMenuOptionN,$A515,$632C);
  xwrite(56,95,qMenuOptionF,$A515,$632C);
  xwrite(56,111,qMenuOptionB,$A515,$632C);
  xwrite(56,127,qMenuOptionR,$A515,$632C);
  xwrite(56,143,qMenuOptionH,$A515,$632C);
  xwrite(56,159,qMenuOptionV,$A515,$632C);
  xwrite(56,175,qMenuOptionZ,$A515,$632C);

  xwrite(56,257,qStatusTitle,$C638,$0415);
  xwrite(56,273,qStatusCalc,$A515,$632C);
  xwrite(56,289,'                             ',$A515,$632C);
  xwrite(56,305,'                             ',$A515,$632C);
  xwrite(56,321,qStatusSize,$A515,$632C);
  xwrite(56,337,'                             ',$A515,$632C);
  xwrite(56,353,'                             ',$A515,$632C);
  xwrite(56,369,qStatusCols,$A515,$632C);
  xwrite(56,385,'                             ',$A515,$632C);
  xwrite(56,401,'                             ',$A515,$632C);
  xwrite(56,417,'                             ',$A515,$632C);

  xwrite(352,257,qQHTitle,$C638,$0415);
  for i:=1 to 10 do
    xwrite(352,257+i SHL 4,qQHEntry[i],$A515,$632C);

  for b:=1 to 8 do mmupd(b);
  menex:=false;
  repeat
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    obri:=bri;
    if ic=qKeySelectFile then begin selefile;menex:=true;end;
    case ic of
      'N':begin
            fina:=input(320,79,fina,33,$0715,$632C);
            mmupd(1);stat:=0;mmupd(8);
          end;
      'F':begin preformat:=not(preformat);mmupd(2);mmupd(8);end;
      'R':begin stat:=0;rota:=(rota+1)AND 3;mmupd(4);mmupd(8);end;
      'H':begin stat:=0;pmh:=not(pmh);mmupd(5);mmupd(8);end;
      'V':begin stat:=0;pmv:=not(pmv);mmupd(6);mmupd(8);end;
      'Z':begin stat:=0;zoom:=not(zoom);mmupd(7);mmupd(8);end;
      'O':begin stat:=0;pmh:=false;pmv:=false;rota:=0;
            for b:=1 to 8 do mmupd(b);end;
      '0':bri:=128;
      '+':if bri<256 then inc(bri);
      '-':if bri>0 then dec(bri);
      '*':begin inc(bri,8);if bri>256 then bri:=256;end;
      '/':begin dec(bri,8);if bri<0 then bri:=0;end;
      #13,#32:begin reload;if stat=1 then recalc;mmupd(8);end;
      'S':save;
    end;
    if bri<>obri then begin stat:=0;mmupd(3);mmupd(8);end;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
    end;
  until menex;
end;

{  FARBEN AUSWHLEN }
procedure colselect;
var cred:boolean;
begin stat:=0;
  topline(qTopLine3);
  cost80(qColSelectHint1);xwrite(0,416,st80,$A515,$632C);
  cost80(qColSelectHint2);xwrite(0,432,st80,$A515,$632C);
  cost80(qColSelectHint3);xwrite(0,448,st80,$A515,$632C);
  xwrite(0,32,qColSelectNo,$E70C,$AAAA);
  xwrite(40,32,qColSelectChar,$E70C,$554A);
  xwrite(112,32,qColSelectActive,$E70C,$AAAA);
  xwrite(168,32,qColSelectName,$E70C,$554A);
  xwrite(544,32,' 0123456789 ',$E70C,$AAAA);
  menex:=false;cred:=true;
  repeat
    if cred then begin cred:=false;
      for i:=0 to 22 do cswc(vp+i,i,i=cp);end;
    cswc(vp+cp,cp,true);
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    x:=vp+cp;y:=48+cp SHL 4;
    case ic of
      #32,#13:coltab[x].active:=char(byte(coltab[x].active) XOR 4);
      '-':coltab[x].active:=#250;
      '+':coltab[x].active:=#254;
      '0'..'9':begin cred:=true;b:=byte(ic)-48;
                 for i:=1 to maxpal do coltab[i].active:=pre[b,i];
               end;
      ^L:begin cred:=true;for i:=3 to maxpal do coltab[i].active:=#250;
           coltab[1].active:=#254;coltab[2].active:=#254;end;
    end;
    case fc of
      #120..#129:begin cred:=true;b:=byte(fc)-119;if b=10 then b:=0;
                   for i:=1 to maxpal do pre[b,i]:=coltab[i].active;
                 end;
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
      #72:if cp<1 then begin
            cp:=0;dec(vp);cred:=true;
            if vp<1 then vp:=1;
          end else begin
            cswc(vp+cp,cp,false);dec(cp);
          end;
      #80:if cp>21 then begin
            cp:=22;inc(vp);cred:=true;
            if vp>maxpal-22 then vp:=maxpal-22;
          end else begin
            cswc(vp+cp,cp,false);inc(cp);
          end;
      #73:begin cred:=true;dec(vp,22);if vp<1 then vp:=1;end;
      #81:begin cred:=true;inc(vp,22);if vp>maxpal-22 then vp:=maxpal-22;end;
      #71:begin cred:=true;cp:=0;vp:=1;end;
      #79:begin cred:=true;cp:=22;vp:=maxpal-22;end;
      #75:coltab[x].active:=#250;
      #77:coltab[x].active:=#254;
    end;
  until menex;
end;

{  FARBEN EDITIEREN }
procedure coledit;
var cred:boolean;
begin stat:=0;
  topline(qTopLine4);
  cost80(qColEditHint1);xwrite(0,416,st80,$A515,$632C);
  cost80(qColEditHint2);xwrite(0,432,st80,$A515,$632C);
  cost80(qColEditHint3);xwrite(0,448,st80,$A515,$632C);
  xwrite(0,32,qColSelectNo,$E70C,$554A);
  xwrite(40,32,qColSelectChar,$E70C,$AAAA);
  xwrite(112,32,qColEditName,$E70C,$554A);
  xwrite(496,32,qColEditRed,$E70C,$AAAA);
  xwrite(544,32,qColEditGreen,$E70C,$554A);
  xwrite(592,32,qColEditBlue,$E70C,$AAAA);
  menex:=false;cred:=true;
  repeat
    if cred then begin cred:=false;
      for i:=0 to 22 do cewc(vp+i,i,i=cp);end;
    cewc(vp+cp,cp,true);
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    x:=vp+cp;y:=48+cp SHL 4;
    if ic=qKeySelectChar then begin
      clipboard:=coltab[x];
      xwrite(48,y,'?',$FFE0,$0415);
      coltab[x].look:=readkey;
    end;
    case ic of
      'N':begin
            clipboard:=coltab[x];
            coltab[x].name:=input(120,y,coltab[x].name,46,$FFE0,$0415);
          end;
      'C':begin
            clipboard:=coltab[x];
            s1:=input(504,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[1],i);
            s1:=input(552,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[2],i);
            s1:=input(600,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[3],i);
            calcco(x);
          end;
      'R':begin
            clipboard:=coltab[x];
            s1:=input(504,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[1],i);
            calcco(x);
          end;
      'G':begin
            clipboard:=coltab[x];
            s1:=input(552,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[2],i);
            calcco(x);
          end;
      'B':begin
            clipboard:=coltab[x];
            s1:=input(600,y,'',4,$FFE0,$0415);
            val(s1,coltab[x].color[3],i);
            calcco(x);
          end;
      ^X:begin clipboard:=coltab[x];coltab[x]:=empty;calcco(x);end;
      ^C:clipboard:=coltab[x];
      ^V:begin
           swapcol:=clipboard;clipboard:=coltab[x];coltab[x]:=swapcol;
           calcco(x);
         end;
      ^I:begin cred:=true;colorimport;end;
    end;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
      #72:if cp<1 then begin
            cp:=0;dec(vp);cred:=true;
            if vp<1 then vp:=1;
          end else begin
            cewc(vp+cp,cp,false);dec(cp);
          end;
      #80:if cp>21 then begin
            cp:=22;inc(vp);cred:=true;
            if vp>maxpal-22 then vp:=maxpal-22;
          end else begin
            cewc(vp+cp,cp,false);inc(cp);
          end;
      #73:begin cred:=true;dec(vp,22);if vp<1 then vp:=1;end;
      #81:begin cred:=true;inc(vp,22);if vp>maxpal-22 then vp:=maxpal-22;end;
      #71:begin cred:=true;cp:=0;vp:=1;end;
      #79:begin cred:=true;cp:=22;vp:=maxpal-22;end;
    end;
  until menex;
end;

{  VORANSICHTen }
procedure preview(hi:boolean);
begin
  back(0,32,639,431);
  if hi then topline(qTopLine5) else topline(qTopLine6);
  cost80(qPreviewHint1);xwrite(0,432,st80,$A515,$632C);
  cost80(qPreviewHint2);xwrite(0,448,st80,$A515,$632C);
  menex:=false;
  repeat
    if (stat=0) OR (hi AND (stat=2)) then reload;
    if not(hi) AND (stat=1) then recalc;
    cost80(brightness);st80[0]:=#14;xwrite(370,448,st80,$0515,$632C);
    if stat=-1 then begin
      xwrite(312-4*byte(err[0]),220,#32+err+#32,$C000,$FFE0);
    end else begin
      if zoom then hiprev_zoom else hiprev_norm;
      if hi then begin
        str(xs:3,s1);str(ys:4,s2);
        cost80(s1+' x'+s2+' '+qPixels);st80[0]:=#15;
      end else begin
        str((xs/10.0):5:1,s1);str((ys/10.0):5:1,s2);
        cost80(s1+' x'+s2+' cm');st80[0]:=#15;
      end;
      xwrite(512,432,st80,$0515,$632C);
    end;
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    obri:=bri;
    if ic=qKeySelectFile then begin selefile;menex:=true;end;
    case ic of
      'Z':if zoom then begin back(64,32,576,431);zoom:=false;end
                  else zoom:=true;
      'S':save;
      'H':begin stat:=0;pmh:=not(pmh);end;
      'V':begin stat:=0;pmv:=not(pmv);end;
      'R':begin back(64,32,576,431);stat:=0;rota:=(rota+1)AND 3;end;
      'O':begin back(64,32,576,431);stat:=0;pmh:=false;pmv:=false;rota:=0;end;
      '0':bri:=128;
      '+':if bri<256 then inc(bri);
      '-':if bri>0 then dec(bri);
      '*':begin inc(bri,8);if bri>256 then bri:=256;end;
      '/':begin dec(bri,8);if bri<0 then bri:=0;end;
    end;
    if bri<>obri then stat:=0;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
    end;
  until menex;
end;

{  PAPERPIC-TABELLE }
procedure viewtab;
var vx,vy,mx,my,miny:integer;
begin
  topline(qTopLine7);
  cost80(qViewTabHint1);xwrite(0,448,st80,$A515,$632C);
  if stat=0 then reload;
  if stat=1 then recalc;
  if preformat then begin
    my:=ys-25;if my<0 then my:=0;
    mx:=xs-76;if mx<0 then mx:=0;
    miny:=0;
  end else begin
    my:=ys-25;if my<0 then my:=0;
    mx:=xs-79;if mx<0 then mx:=0;
    miny:=1;
  end;
  menex:=false;vx:=1;vy:=miny;
  repeat
    if stat=2 then begin
      if preformat then begin
        for i:=0 to 25 do vtpm(vx,vy+i,i);
      end else begin
        for i:=0 to 25 do vtnp(vx,vy+i,i);
      end;
    end else begin
      back(0,48,639,447);
      xwrite(312-4*byte(err[0]),220,#32+err+#32,$C000,$FFE0);
    end;
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    if ic='S' then save;
    if ic='F' then begin preformat:=not(preformat);menex:=true;end;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
      #72:if vy>miny then dec(vy);
      #75:if vx>1 then dec(vx);
      #77:if vx<mx then inc(vx);
      #80:if vy<my then inc(vy);
      #71:begin vx:=1;vy:=miny;end;
      #79:begin vx:=mx;vy:=my;end;
    end;
  until menex;
end;

{  PAPERPIC-LEGENDE }
procedure legend;
var cred:boolean;vy,my:integer;
begin
  topline(qTopLine8);
  cost80(qViewLegendHint1);xwrite(0,448,st80,$A515,$632C);
  xwrite(0,32,qViewLegendChar,$E70C,$AAAA);
  xwrite(72,32,qViewLegendName,$E70C,$554A);
  xwrite(456,32,qViewLegendStat,$E70C,$AAAA);
  if stat=0 then reload;
  if stat=1 then recalc;
  if stat=2 then fct:=100.0/(xs*ys);
  my:=usco-24;if my<0 then my:=0;
  menex:=false;cred:=true;vy:=0;
  repeat
    if stat=2 then begin for i:=0 to 24 do begin
      y:=48+i SHL 4;
      if vy+i=0 then begin
         str((xs/10.0):0:1,s1);str((ys/10.0):0:1,s2);
         s1:=' *        '+qSize+' '+s1+' cm x '+s2+' cm';
         cost80(s1);st80[0]:=#58;
         str(xs*ys:5,s1);
         xwrite(0,y,st80+s1+' '+qPixels+' = 100.00% ',$CE73,$000E);
      end else begin
        x:=ass[vy+i];w:=anz[x];
        if w>0 then begin
          s1:='   ';s1[2]:=coltab[x].look;xwrite(0,y,s1,$C618,$000E);
          xwrite(24,y,'',co1[x],co2[x]);
          st80:=e80;st80[0]:=#50;
          b:=byte(coltab[x].name[0]);if b>46 then b:=46;
          move(coltab[x].name[1],st80[3],b);
          str(w:5,s1);str((w*fct):7:2,s2);
          s1:=s1+' '+qPixels+' ='+s2+'% ';
          xwrite(64,y,st80+s1,$C618,$000E);
        end else xwrite(0,y,e80,$C618,$000E);
      end;
    end end else begin
      back(0,48,639,447);
      xwrite(312-4*byte(err[0]),220,#32+err+#32,$C000,$FFE0);
    end;
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    if ic='S' then save;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
      #72:if vy>0 then dec(vy);
      #80:if vy<my then inc(vy);
    end;
  until menex;
end;

{  HILFE }
procedure help;
var vy,my:integer;tfc,tbc:word;
begin
  topline(qTopLine1);
  cost80(qHelpHint1);xwrite(0,448,st80,$A515,$632C);
  my:=maxhelp-25;if my<0 then my:=0;
  menex:=false;vy:=1;
  repeat
    st80[0]:=#80;
    for i:=0 to 25 do begin
      y:=32+i SHL 4;x:=vy+i;
      move(helptext[x,-4],tfc,2);
      move(helptext[x,-2],tbc,2);
      move(helptext[x,0],st80[1],80);
      xwrite(0,y,st80,tfc,tbc);
    end;
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
      #72:if vy>1 then dec(vy);
      #80:if vy<my then inc(vy);
      #73:begin dec(vy,25);if vy<1 then vy:=1;end;
      #81:begin inc(vy,25);if vy>my then vy:=my;end;
    end;
  until menex;
end;

{  REGISTRIERTE VERSION }
procedure registered;
begin
  back(0,32,639,463);
  topline(qTopLine9);
  i:=192-RegisteredMax SHL 4;
  for y:=1 to RegisteredMax do begin
    w:=$A515;x:=76;w1:=i+y SHL 4;
    a:=1;s1:=RegisteredText[y];
    repeat
      z:=a;repeat;inc(z);fc:=s1[z];
      until fc IN ['|','"','$','%','&','~','\'];
      s2:=copy(s1,a,z-a);
      xwrite(x,w1,s2,w,$632C);
      case fc of '|':w:=$A515;'"':w:=$E63F;'$':w:=$FF0A;
                 '%':w:=$A715;'&':w:=$A71C;'~':w:=$E515;end;
      inc(x,byte(s2[0]) SHL 3);a:=z+1;
    until fc='\';fc:=#0;
  end;
  menex:=false;
  repeat
    fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
    case fc of
      #59..#68:begin menex:=true;gmv:=byte(fc)-58;end;
    end;
  until menex;
end;

{  UNREGISTRIERTE VERSION }
procedure delinquent;
var sect,lastse:longint;rnmode:boolean;curno:string;
begin
  back(0,32,639,463);
  topline(qTopLine9);
  i:=302-NotRegisteredMax SHL 4;
  for y:=1 to NotRegisteredMax do begin
    w:=$A515;x:=76;w1:=i+y SHL 4;
    a:=1;s1:=NotRegisteredText[y];
    repeat
      z:=a;repeat;inc(z);fc:=s1[z];
      until fc IN ['|','"','$','%','&','~','\'];
      s2:=copy(s1,a,z-a);
      xwrite(x,w1,s2,w,$632C);
      case fc of '|':w:=$A515;'"':w:=$E63F;'$':w:=$FF0A;
                 '%':w:=$A715;'&':w:=$A71C;'~':w:=$E515;end;
      inc(x,byte(s2[0]) SHL 3);a:=z+1;
    until fc='\';fc:=#0;
  end;
  xwrite(76,384,qRegShowDelay,$0015,$A515);
  menex:=false;lastse:=-32768;rnmode:=false;curno[0]:=#0;
  repeat
    nt:=st-timer+rt;
    sect:=(nt DIV 18);
    if not(rnmode) AND (sect<>lastse) then begin
      if sect<1 then
        xwrite(76,384,qRegReady,$0380,$A515);
      if sect=1 then xwrite(228,384,qRegLastSecond,$632C,$A515);
      if sect>1 then begin
        str(sect,s1);
        xwrite(228,384,qRegAnySecondPrefix+s1+qRegAnySecondPostfix,$632C,$A515);
      end;
    end;
    if keypressed then begin
      fc:=#0;ic:=upcase(readkey);if ic=#0 then fc:=readkey;
      case fc of
        #59..#68:if sect<1 then begin menex:=true;gmv:=byte(fc)-58;end;
      end;
      case ic of
        '0'..'9','A'..'F','-':begin
          if not(rnmode) then
            xwrite(76,384,qRegInputNumber,$0015,$A515);
          rnmode:=true;
          if curno[0]<#19 then curno:=curno+ic;
          xwrite(228,384,curno+'_',$632C,$A515);
        end;
        #13:if curno=regno then begin rt:=0;menex:=true;nt:=-1;end else begin
              xwrite(76,384,qRegShowDelay,$0015,$A515);
              rnmode:=false;sect:=-32768;curno:='';
            end;
      end;
    end;
    lastse:=sect;
  until menex AND (nt<1);
end;


{  HAUPTTEIL }
begin
  startup;
  config;
  s1:=paramstr(1);
  if s1<>'' then fina:=s1;
  stat:=0;gmv:=9;st:=timer;

  repeat
    case gmv of
      1:help;
      2:mainmenu;
      3:colselect;
      4:coledit;
      5:preview(true);
      6:preview(false);
      7:viewtab;
      9:if rt=0 then registered else delinquent;
      8:legend;
    else gmv:=2;end;
  until gmv=10;
  quitprogram;
end.